package org.objectweb.telosys.screen.core;

import javax.servlet.http.HttpSession;

import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.common.TelosysObject;
import org.objectweb.telosys.rpl.ScreenRequestParameters;
import org.objectweb.telosys.screen.env.ScreenApplication;
import org.objectweb.telosys.screen.env.ScreenSession;

/**
 * A "dummy" ScreenContext implementation used only for ScreenContext slot reservation in the ScreenSession 
 * 
 * @author Laurent GUERIN
 *  
 */
public class DummyScreenContext extends TelosysObject implements ScreenContext
{
	private static final long serialVersionUID = 1L;
    
    public DummyScreenContext()
    {
    }

    //---------------------------------------------------------------------------
    // get the screen name
    //---------------------------------------------------------------------------
    public String getScreenName()
    {
        return "DUMMY_SCREEN_CONTEXT";
    }

    public int getScreenId()
    {
        return -1 ;
    }

    //---------------------------------------------------------------------------
    /* (non-Javadoc)
     * @see org.objectweb.telosys.screen.core.ScreenContext#getScreenApplication()
     * <!> DEPRECATED : Do not use _screenSession
     */
    public ScreenApplication getScreenApplication() // Not used in Telosys framework
    {
        return null ;
    }

    //---------------------------------------------------------------------------
    /* (non-Javadoc)
     * @see org.objectweb.telosys.screen.core.ScreenContext#getScreenSession()
     * <!> DEPRECATED : Do not use _screenSession
     */
    public ScreenSession getScreenSession() // Not used in Telosys framework
    {
        return null ;
    }

    //---------------------------------------------------------------------------
    /* (non-Javadoc)
     * @see org.objectweb.telosys.screen.core.ScreenContext#getHttpSession()
     * <!> DEPRECATED : Do not use _screenSession
     */
    public HttpSession getHttpSession() // Not used in Telosys framework
    {
        return null ;
    }

    public boolean hasBeenReused()
    {
        return false ;
    }
    
    //---------------------------------------------------------------------------
    // get/set/clear the current data of the screen
    //---------------------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.screen.core.ScreenContext#getCurrentData()
     */
    public ScreenData getCurrentData()
    {
        return null ;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.screen.core.ScreenContext#getOrCreateCurrentData()
     */
    public ScreenData getOrCreateCurrentData()
    {
        return null ;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.screen.core.ScreenContext#setCurrentData(org.objectweb.telosys.screen.core.ScreenData)
     */
    public void setCurrentData(ScreenData data)
    {
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.screen.core.ScreenContext#clearCurrentData()
     */
    public void clearCurrentData()
    {
    }

    //==============================================================================
    // ABSTRACT METHODS IMPLEMENTATIONS
    //==============================================================================

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.screen.core.ScreenContext#getScreenActions()
     */
    public ScreenActions getScreenActions()
    {
        return null ;
    }
    
    /* (non-Javadoc)
     * @see org.objectweb.telosys.screen.core.ScreenContext#getOrCreateScreenActions()
     */
    public ScreenActions getOrCreateScreenActions() throws TelosysException
    {
        return null ;
    }

    public ScreenManager getScreenManager() // v 1.0.0
    {
        return null ;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.screen.core.ScreenContext#createNewScreenData()
     */
    public ScreenData createNewScreenData()
    {
        return null ;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.screen.core.ScreenContext#beginAction()
     */
    public ScreenData beginAction()
    {
        return null ;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.screen.core.ScreenContext#cancelAction()
     */
    public void cancelAction()
    {
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.telosys.screen.core.ScreenContext#getDataForLoad(org.objectweb.telosys.rpl.ScreenRequest)
     */
    public ScreenData getDataForLoad() //throws TelosysException
    {
        return null;
    }

    /* (non-Javadoc)
     * @see org.objectweb.telosys.screen.core.ScreenContext#getTempData()
     */
    public ScreenData getTempData() 
    {
        return null;
    }

    //---------------------------------------------------------------------------
    // Screen Context attributes
    //---------------------------------------------------------------------------
    /* (non-Javadoc)
     * @see org.objectweb.telosys.screen.core.ScreenContext#setAttribute(java.lang.String, java.lang.Object)
     */
    public Object setAttribute(String name, Object value)
    {
        return null;
    }

    /* (non-Javadoc)
     * @see org.objectweb.telosys.screen.core.ScreenContext#getAttribute(java.lang.String)
     */
    public Object getAttribute(String name)
    {
        return null;
    }

    /* (non-Javadoc)
     * @see org.objectweb.telosys.screen.core.ScreenContext#removeAttribute(java.lang.String)
     */
    public Object removeAttribute(String name)
    {
        return null;
    }

    public void eventCreate(ScreenSession screenSession, ScreenRequestParameters params) throws TelosysException
    {
    }
    
    public void eventReuse(ScreenSession screenSession, ScreenRequestParameters params) throws TelosysException
    {
    }

    public String toString()
    {
        return "DummyScreenContext" ;
    }
}