package org.objectweb.telosys.screen.core;

import org.objectweb.telosys.common.TelosysException;
import org.objectweb.telosys.screen.env.ScreenSession;


/**
 * The ScreenProvider interface 
 * 
 * Implemented by "StandardScreenRegistry" 
 * 
 * 
 * @author Laurent GUERIN
 * 
 * 
 *
 */
public interface IScreenProvider  
{
    //public ScreenContext getScreen ( String sScreenName, ScreenSession screenSession ) throws TelosysException ;
    // v 0.9.4 
    /**
     * Creates a new ScreenContext instance for the given ScreenContext Name and ScreenContext ID
     * 
     * @param screenSession
     * @param sScreenName
     * @param iScreenId
     * @return
     * @throws TelosysException
     */
    public ScreenContext getScreen ( ScreenSession screenSession, String sScreenName, int iScreenId) throws TelosysException ;
}
