package org.objectweb.telosys.uil.i18n;

import javax.servlet.ServletContext;

/**
 * The Interface for translators loading
 *  
 * @author Nicolas MARQUES
 * @since v 1.0.3
 */
public interface ITranslatorLoader {

	/**
     * Loads the Translator object for the given JSP file and the given languages
     * 
     * @param servletContext the standard ServletContext
     * @param sJspFile the JSP file that needs a translator
     * @param languages the list of languages to load 
     * 
     * @return the Translator, or null if none
     */
    public Translator loadTranslations(ServletContext servletContext, String sJspFile, String[] languages);

}