package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.widget.TagDefaultValues;
import org.objectweb.telosys.util.web.ScreenURI;

/**
 * @author Laurent GUERIN
 *  
 */
public class UrlScreenmap extends CommonTagSupport // TagSupport
{
    private static final String  TAG_NAME  = "url_screenmap";
    
    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String _sScreenName    = null;

    private String _sScreenType    = null;

    private String _sContextId     = null;

    private String _sContextName   = null; // new in v 0.9.9 

    private String _sContextAction = null;

    private String _sParams        = null; // new in v 0.9.9

    //----------------------------------------------------------------
    public void setName(String v) // Attribute "name" ( old name for "screenname" )
    {
        _sScreenName = v;
    }
    public void setScreenname(String v) // Attribute "screenname"
    {
        _sScreenName = v;
    }
    private String getScreenname()  // v 1.0.4
    {
        return replaceSymbolicVar(_sScreenName);  
    }

    //----------------------------------------------------------------
    public void setType(String v) // Attribute "type" ( old name for "screentype" )
    {
        _sScreenType = v;
    }
    public void setScreentype(String v) // Attribute "screentype"
    {
        _sScreenType = v;
    }
    private String getScreentype()  // v 1.0.4
    {
        return replaceSymbolicVar(_sScreenType);  
    }

    //----------------------------------------------------------------
    public void setId(String v) // Attribute "id" ( old name for "contextid" )
    {
        _sContextId = v;
    }
    public void setContextid(String v) // Attribute "contextid"
    {
        _sContextId = v;
    }
    public String getContextid()  // v 1.0.4
    {
        if (_sContextId != null)
        {
            //--- Context ID has been set
            return replaceSymbolicVar( _sContextId );
        }
        else
        {
            //--- Not set : is there a default value for this attribute ?
            String s = TagDefaultValues.getDefaultAttributeValue(pageContext, TAG_NAME, "contextid" ); // v 1.0.4
            if ( s != null )
            {
                return replaceSymbolicVar( s );
            }
        }
        return null ;
    }

    //----------------------------------------------------------------
    public void setContextname(String v) // Attribute "contextname"
    {
        _sContextName = v;
    }
    private String getContextname()  // v 1.0.4
    {
        return replaceSymbolicVar(_sContextName);  
    }

    //----------------------------------------------------------------
    public void setAction(String v) // Attribute "action" ( old name for "contextaction" )
    {
        _sContextAction = v;
    }
    public void setContextaction(String v) // Attribute "contextaction"
    {
        _sContextAction = v;
    }
    private String getContextaction()  // v 1.0.4
    {
        return replaceSymbolicVar(_sContextAction);  
    }

    //----------------------------------------------------------------
    public void setParams(String v) // Attribute "params"
    {
        _sParams = v;
    }
    private String getParams()  // v 1.0.4
    {
        return replaceSymbolicVar(_sParams);  
    }

    //----------------------------------------------------------------
    // Tag open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();
        
        //--- "http://server:port/webapp/screenmap/name-type/id-ctx:action?params"
        
        //ScreenURI uri = new ScreenURI(_sName, _sType, _sContextId, _sContextName, _sAction, _sParams); // v 1.0.4 
        ScreenURI uri = new ScreenURI( getScreenname(), getScreentype(), getContextid(), getContextname(), getContextaction(), getParams() ); // v 1.0.4 

        HttpServletRequest req = ( HttpServletRequest ) pageContext.getRequest() ;
        print(out, uri.getFullURL(req) );
        
        return (SKIP_BODY);
    }
    
    //----------------------------------------------------------------
}